#include "buffer_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
  	printf("BUFFER  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		buffer_id=atoi(optarg);
			printf("Buffer id: %d\n",buffer_id);
        	break;
		case 's':
        		control_id=atoi(optarg);
			printf("Control id: %d\n",control_id);		  
		break;  
		case 'd':
       			rando_id=atoi(optarg);
			printf("Rando id: %d\n",rando_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}		
	}

	if (control_id<0 || buffer_id<0 || rando_id<0)
	{
		printf("Need two mandatory parameter: -m <buffer_id> -s <control_id> -d <rando_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"BUFFER");
	n=InitCommManagerN(buffer_id,modulename);
	if(n<0) return(-1);


	printf("Register module BUFFER: OK\n");

	//For ever loop
	while(1){


	

	
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT)
		{
			BUFFER_Init();
			BUFFER_Stat_Init();
		} 
		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			BUFFER_Stat_Run0();
		 	BUFFER_Run();
			BUFFER_Stat_Run1();
		}
		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			BUFFER_Stop();
			BUFFER_Stat_Stop();
		} 
	}

	return(1);

}
