#include <stdio.h>
#include <math.h>
#include "estadisticas_cm.h"

#define N 192

/* Con este cdigo pdemos
/*esta funcin pasa los caracteres a binario*/

void char2bin (int vout[], unsigned char code)
{
	int  i,k;
	int  remain;

	
		for (k=0; k<8; k++)
		{
			remain = code % 2;
			code = code / 2;
			vout[k]=remain;
		}
	
	//return (bytes*8);
}

/*con esta funcin podemos sacar dos BER,s, 1. La total, ejecutando todo el codigo, 2.Parcial, ejecutando solo la parte de symbol level processing*/
//  si accion=1: BER total, si accion=2:BER parcial
// bits: dependiendo de la modulacin en la que estamos simulando, el # de bits variara.

compara (int bits, int accion, char *fitxer1, char *fitxer2, symbol *inicial, symbol *final)

{
	int maxdB=15,mindB=0;
	char mod[]="prueba";
	
	
	FILE *f1,*f2,*f3,*compar;

	char p1,p2;
	int bitf1[8],bitf2[8];
	char fitxer[50];
	char resultats[50];
	char tmp[60];

	int t,i;
	float BER=0.0;
	int errors=0;//bits=0;

	compar= fopen ("/home/v1.7/estadisticas/compar.csv","a");
	sprintf(resultats,"/home/v1.7/estadisticas/BER%s.txt",mod);

	f3=fopen(resultats,"a");

	sprintf(tmp,"| MODE    | SNR(dB) | ERRORS  | BITS    | BER      |\n");
	fprintf(f3,tmp);
	sprintf(tmp,"----------------------------------------------------\n");
	fprintf(f3,tmp);

	if (accion == 1)
	{
		for (i=0;i<maxdB;i++){
		
			f2=fopen("rfc793.txt","r");
			sprintf(fitxer,"%s%ddB.txt",mod,i);
			f1=fopen(fitxer,"r");
			if((f1==NULL)||(f2==NULL))
			{
				printf("Error al abrir fichero\n");
				exit(0);           
			}
			while (!feof(f1))
			{
				fscanf(f1,"%c",&p1); 
				fscanf(f2,"%c",&p2);
				char2bin (bitf1, p1);
				char2bin (bitf2, p2);
				for (t=0;t<8;t++){
					if (bitf1[t]!=bitf2[t]) errors++;
				}
				bits=bits+8;
			}
			BER= (float)(errors)/(float)(bits);
			sprintf(tmp,"| %7s | %7d | %7d | %7d | %7f |\n",mod,i,errors,bits,BER);
			fprintf(f3,tmp);

			fclose(f1);
			fclose(f2);
		
		}

	}

	if(accion ==-1)
	{
		/*comparamos symbol inicial con symbol final*/

		printf("Estoy dentro de compara\n");



/*		for (i=0;i<N;i++) {
	   
		fprintf(compar,"%f;",inicial[i].re);
		fprintf(compar,"%f;",inicial[i].im);

	    fprintf(compar,"%f;",final[i].re);
		fprintf(compar," %fi\n",final[i].im);

   }*/
		/*for(i=0;i<N;i++)
			if (i%2 ==0)
				inicial[i].re=0.50;*/

		//inicial[2].re=0.37;

		//printf("Inicial[2]:%f\nFinal[2]:%f\n",inicial[2],final[2]);
		for(i=0;i<N;i++)
		{

			
			//inicial[i].re= inicial[i].re *1000.0;
			//inicial[i].im= inicial[i].im * 1000.0;
			//final[i].re= final[i].re * 1000.0;
			//final[i].im= final[i].im * 1000.0;

			fprintf(compar,"%f;",inicial[i].re);
			fprintf(compar,"%f;",inicial[i].im);

			fprintf(compar,"%f;",final[i].re);
			fprintf(compar," %fi\n",final[i].im);
				

			//if((((int)inicial[i].re!=(int)final[i].re))||(((int)inicial[i].im!=(int)final[i].im)))

			if(((final[i].re-inicial[i].re)>0.2) || ((final[i].re-inicial[i].re)<-0.2) || ((final[i].im-inicial[i].im)>0.2) || ((final[i].im-inicial[i].im)<-0.2))
			{
				errors++;
			/*	if(((inicial[i].re==0.0) & (final[i].re ==-0.0))| ((inicial[i].im==0.0) & (final[i].im ==-0.0)))
					errors--;*/
			}

		}

		printf("Errors:%d\n",errors);
		printf("Bits:%d\n",bits);


		BER= (float)(errors)/(float)(bits);
		sprintf(tmp,"| %7s | %7d | %7d | %7d | %7f |\n",mod,i,errors,bits,BER);
		fprintf(f3,tmp);
	
		}
	
	printf("Valor de BER:%f\n",BER);

	fclose(f3);	 
}
