#include "estadisticas_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("ESTADISTICAS  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:p:e:")) != -1)//d:
		switch(c){
		case 'm':
        		estadisticas_id=atoi(optarg);
			printf("Estadisticas id: %d\n",estadisticas_id);
        	break;
		case 'p':
        		pilot_id=atoi(optarg);
			printf("Pilot id: %d\n",pilot_id);
        	break;		
		case 'e':
        		depilot_id=atoi(optarg);
			printf("Depilot id: %d\n",depilot_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (estadisticas_id<0 || pilot_id<0 || depilot_id<0)
	{
		printf("Need two mandatory parameter: -m <estadisticas_id> -p <pilot_id> -e <depilot_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"ESTADISTICAS");
	n=InitCommManagerN(estadisticas_id,modulename);
	if(n<0) return(-1);


	printf("Register module ESTADISTICAS: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) ESTADISTICAS_Init();

		//RUN SECTION
		if (testbed_status==TB_RUN) ESTADISTICAS_Run();

		//STOP SECTION
		if (testbed_status==TB_STOP) ESTADISTICAS_Stop();
	}

	return(1);

}
