#include "deinter_cm.h"
int stats_time, n, log_id;
double sts_count;
/*char log_msg[20];*/
struct timeval tm1, tm2;

//INIT SECTION
void DEINTER_Stat_Init()
{
	log_id=CreateLog();										/*Creating th log */
	if ((n=InitStatistics(deinter_id))<0)                   /*Initialising the statistics for the module */ 
		UnrecoveryError("Error initialising Statistics");  
	sts_count=0;											
	stats_time = CreateStat("DEINTER");						/*Creating the stat referenced on module_XXX.sts */
	sprintf(log_msg,"Stats of Module_DEINTER started succesfully");
	WriteLog(log_id,log_msg);	
}

//RUN SECTION
void DEINTER_Stat_Run0()
{
		gettimeofday(&tm1,NULL);							/*getting the time before process the module (tm1) */
}
void DEINTER_Stat_Run1()
{
	gettimeofday(&tm2,NULL);								/*getting the time after procces the module (tm2) */
	sts_count = (tm2.tv_usec-tm1.tv_usec);					/*difference between two times */
	sprintf(log_msg,"Module_DEINTER time %f us",&sts_count);		/*Log the result in LogFile and Statistics */
	WriteLog(log_id, log_msg);
	SetStatValue(stats_time,&sts_count,0);
	LogStat(log_id,stats_time,0);
}
void DEINTER_Stat_Stop()
{
	DeleteStat(stats_time);									/* Delete variable stats for the module */
	//CloseStatistics();
	sprintf(log_msg,"Stats of Module_DEINTER stopped succesfully");
	WriteLog(log_id,log_msg);
}
