#include "derando_cm.h"


void derandomize(int datain[],int dataout[],int length)
{
  int xor1=0,i=0, k=0;

  int arrayinit[15]= {1,0,0,1,0,1,0,1,0,0,0,0,0,0,0};

  for (i=1; i<=length; i++)
    {
      if (arrayinit[13]==arrayinit[14])
	xor1=0;
      else
	xor1=1;

      for (k=14;k>=1;k--)
     	arrayinit[k]=arrayinit[k-1];

      arrayinit[0]=xor1;

      if (datain[i-1]==xor1)
	dataout[i-1]=0;
      else
    	dataout[i-1]=1;

//      printf(" dataout= %d \n",dataout[i-1]);
    }
}

/**********************************************************
INIT
**********************************************************/
void DERANDO_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create deRandoflow_rx\n");
	//Create deRandoflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 2000;
	fconf.magic = (dersol_id*derando_id)%(dersol_id+derando_id);
	fconf.name = "deRando_flow_rx";
	deRando_flow_rx = NewFlow(derando_id, dersol_id, fconf);
	if (deRando_flow_rx<0) UnrecoveryError("Could not create flow with deRandomizer");
	WriteLog(logCMFile, "deRandoflow_rx: OK\n");

/*	WriteLog(logCMFile, "Create deRandoflow_tx\n");
	//Create deRandoflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3500;
	fconf2.magic = (derando_id*result_id)%(derando_id+result_id);
	fconf2.name = "deRando_flow_tx";
	deRando_flow_tx = NewFlow(derando_id, result_id, fconf2);
	if (deRando_flow_tx<0) UnrecoveryError("Could not create flow with RSolomon");
	WriteLog(logCMFile, "deRandoflow_tx: OK\n");*/
	time_slot=0;
	pt=0;
	last_snr=0.0;
////////// INIT ////////////
	last_mod=1;
	last_mode=0; ////// SI es vol començar per un altre SNR s'ha de canviar aquí tb.
}

/*************************************************************
STOP
************************************************************/
void DERANDO_Stop() {

	DeleteFlow(deRando_flow_rx);
	WriteLog(logCMFile, "DeleteFlow deRando_flow_rx\n");

	DeleteFlow(deRando_flow_tx);
	WriteLog(logCMFile, "DeleteFlow deRando_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(derando_id);

	exit(0);
}





/****************************************************************
RUN
****************************************************************/
void DERANDO_Run(){

	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start");
    	time_slot=GetTimeStamp();

  	int n,i;
 	dersol2derando flow_rx;
 	rand2result flow_tx;
	int info_in[864];
	int info_out[864];
	char root[]="/home/odissey09/work/phal_trunk/\0";
	char name[40];

	if(GetFlowStatus(deRando_flow_rx))
	{
  		n=ReadFlow(deRando_flow_rx,sizeof(flow_rx),&flow_rx);
  		if (n>0)
		{

//			sprintf(log_msg,"timeslot, %d p=%d",time_slot,n);
//			WriteLog(logCMFile, log_msg);

			flow_tx.length=char2bin (info_in,flow_rx.info,flow_rx.length);
//			printf("length = %d", flow_rx.length);

//			sprintf(log_msg,"length %d", flow_rx.length);
//			WriteLog(logCMFile, log_msg);

			//Prova de sortida del derando
			WriteLog(logCMFile, "Info in bits");
 			for (i=0; i<flow_tx.length; i++){
				sprintf(log_msg,"[%d]%d\n",i, info_in[i]);
				WriteLog(logCMFile, log_msg);
			}

  			derandomize(info_in,info_out,flow_tx.length);

			//Prova de sortida del derando
/*			WriteLog(logCMFile, "Info out en bits");
 			for (i=0; i<(flow_rx.length*8); i++){
				sprintf(log_msg,"[%d]%d\n",i, info_out[i]);
				WriteLog(logCMFile, log_msg);
			}*/

 			flow_tx.length=bin2char (info_out, flow_tx.info, flow_tx.length);

			//Prova de sortida del derando
/* 			for (i=0; i<flow_rx.length; i++){
				sprintf(log_msg,"[%d]%c\n",i, flow_tx.info[i]);
				WriteLog(logCMFile, log_msg);
			}*/

		//	printf("mod=%d mode=%d\n", flow_rx.mod, flow_rx.mode);

			if (flow_rx.es_ovr_n0!=last_snr)
			{

				switch(last_mod)
				{
				case 1:
					if(last_mode==0)
					{
						for(i=0; i<15;i++){
							if((int)last_snr==i){
								sprintf(name,"%sBPSK%ddB.txt",root,i);
								break;
							}
						}
					}
					break;
				case 2:
					if(last_mode==0)
					{
						for(i=0; i<15;i++){
							if((int)last_snr==i){
								sprintf(name,"%sQPSK0%ddB.txt",root,i);
								break;
							}
						}
					}

					if(last_mode==1)
					{
						for(i=0; i<15;i++){
							if((int)last_snr==i){
								sprintf(name,"%sQPSK1%ddB.txt",root,i);
								break;
							}
						}
					}
					break;

				case 4:
					if(last_mode==0)
					{
						for(i=0; i<30;i++){
							if((int)last_snr==i){
								sprintf(name,"%s16QAM0%ddB.txt",root,i);
								break;
							}
						}
					}

					if(last_mode==1)
					{
						for(i=0; i<30;i++){
							if((int)last_snr==i){
								sprintf(name,"%s16QAM1%ddB.txt",root,i);
								break;
							}
						}
					}
					break;
				case 6:
					if(last_mode==0)
					{
						for(i=0; i<40;i++){
							if((int)last_snr==i){
								sprintf(name,"%s64QAM0%ddB.txt",root,i);
								break;
							}
						}
					}

					if(last_mode==1)
					{
						for(i=0; i<40;i++){
							if((int)last_snr==i){
								sprintf(name,"%s64QAM1%ddB.txt",root,i);
								break;
							}
						}
					}
					break;

				}

				escribe_archivo(name,info_temp, pt);//Concatena en archivo cada frase2*/
				last_mod=flow_rx.mod;
				last_mode=flow_rx.mode;
				last_snr=flow_rx.es_ovr_n0;
				pt=0;

			}

			for(i=0;i<flow_tx.length;i++)
			{
				info_temp[i+pt]=flow_tx.info[i];
				//printf("pt=%d\n",pt);

			}
			pt+=flow_tx.length;


		/*void escribe_archivo(char nombre[],unsigned char data[], int length_max)

			if(GetFlowStatus(deRando_flow_tx))
			{
 				n=WriteFlow(deRando_flow_tx,sizeof(flow_tx),&flow_tx);
	 			if(n<0)
  		  			WriteLog(logCMFile, "Error  writing the flow");
			}*/
		}
  		else
		{
//			sprintf(log_msg,"mal llegit, %d ",n);
//			WriteLog(logCMFile, log_msg);

			WriteLog(logCMFile, "Error  writing the flow");
		}
	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Derando time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

