
object {
	obj_name=control
	exe_name=control
	proc=100
	
	outputs {
		name=Control_flow
		remote_itf=buffer_flow_rx
		remote_obj=buffer
	}
}

object {
	obj_name=buffer
	exe_name=buffer
	proc=100
	
	inputs {
		name=buffer_flow_rx
		remote_itf=Control_flow
		remote_obj=Control
	}
	outputs {
		name=Buffer_flow_tx
		remote_itf=Rando_flow_rx
		remote_obj=rando
	}
}

object {
	obj_name=rando
	exe_name=rando
	proc=100
	
	inputs {
		name=Rando_flow_rx
		remote_itf=Buffer_flow_tx
		remote_obj=buffer
	}
	outputs {
		name=Rando_flow_tx
		remote_itf=RSol_flow_rx
		remote_obj=rsol
	}
}


object {
	obj_name=rsol
	exe_name=rsol
	proc=100
	
	inputs {
		name=RSol_flow_rx
		remote_itf=Rando_flow_tx
		remote_obj=rando
	}
	outputs {
		name=RSol_flow_tx
		remote_itf=Cconv_flow_rx
		remote_obj=cconv
	}
}

object {
	obj_name=cconv
	exe_name=cconv
	proc=100
	inputs {
		name=Cconv_flow_rx
		remote_itf=RSol_flow_tx
		remote_obj=rsol
	}
	outputs {
		name=Cconv_flow_tx
		remote_itf=Inter_flow_rx
		remote_obj=inter
	}
}

object {
	obj_name=inter
	exe_name=inter
	proc=100
	inputs {
		name=Inter_flow_rx
		remote_itf=Cconv_flow_tx
		remote_obj=cconv
	}
	outputs {
		name=Inter_flow_tx
		remote_itf=Smap_flow_rx
		remote_obj=smap
		bw = 100
	}
}

object {
	obj_name=smap
	exe_name=smap
	proc=100
	inputs {
		name=Smap_flow_rx
		remote_itf=Inter_flow_tx
		remote_obj=inter
	}
	outputs {
		name=Smap_flow_tx
		remote_itf=Pilot_flow_rx
		remote_obj=pilot
		bw = 100
	}
}

object {
	obj_name=pilot
	exe_name=pilot
	proc=100
	inputs {
		name=Pilot_flow_rx
		remote_itf=Smap_flow_tx
		remote_obj=smap
	}
	outputs {
		name=Pilot_flow_tx
		remote_itf=Ifft_flow_rx
		remote_obj=ifft
		bw = 100
	}
}

object {
	obj_name=ifft
	exe_name=ifft
	proc=100
	inputs {
		name=Ifft_flow_rx
		remote_itf=Pilot_flow_tx
		remote_obj=pilot
	}
	outputs {
		name=Ifft_flow_tx
		remote_itf=Cyclic_flow_rx
		remote_obj=cyclic
		bw = 100
	}
}

object {
	obj_name=cyclic
	exe_name=cyclic
	proc=100
	inputs {
		name=Cyclic_flow_rx
		remote_itf=Ifft_flow_tx
		remote_obj=ifft
	}
	outputs {
		name=Cyclic_flow_tx
		remote_itf=ChannelFFT_flow_rx
		remote_obj=channelFFT
		bw = 100
	}
}

object {
	obj_name=channelFFT
	exe_name=channelFFT
	proc=100
	inputs {
		name=ChannelFFT_flow_rx
		remote_itf=Cyclic_flow_tx
		remote_obj=cyclic
	}
	outputs {
		name=ChannelFFT_flow_tx
		remote_itf=Decyclic_flow_rx
		remote_obj=decyclic
		bw = 100
	}
}

object {
	obj_name=decyclic
	exe_name=decyclic
	proc=100
	inputs {
		name=Decyclic_flow_rx
		remote_itf=ChannelFFT_flow_tx
		remote_obj=channelFFT
	}
	outputs {
		name=Decyclic_flow_tx
		remote_itf=Fft_flow_rx
		remote_obj=fft
		bw = 100
	}
}

object {
	obj_name=fft
	exe_name=fft
	proc=100
	inputs {
		name=Fft_flow_rx
		remote_itf=Decyclic_flow_tx
		remote_obj=decyclic
	}
	outputs {
		name=Fft_flow_tx
		remote_itf=Depilot_flow_rx
		remote_obj=depilot
		bw = 100
	}
}

object {
	obj_name=depilot
	exe_name=depilot
	proc=100
	inputs {
		name=Depilot_flow_rx
		remote_itf=Fft_flow_tx
		remote_obj=fft
	}
	outputs {
		name=Depilot_flow_tx
		remote_itf=Calsoft_flow_rx
		remote_obj=calsoft
		bw = 100
	}
}

object {
	obj_name=calsoft
	exe_name=calsoft
	proc=100
	inputs {
		name=Calsoft_flow_rx
		remote_itf=Depilot_flow_tx
		remote_obj=depilot
	}
	outputs {
		name=Calsoft_flow_tx
		remote_itf=DeInter_flow_rx
		remote_obj=deinter
		bw = 100
	}
}

object {
	obj_name=deinter
	exe_name=deinter
	proc=100
	inputs {
		name=DeInter_flow_rx
		remote_itf=Calsoft_flow_tx
		remote_obj=calsoft
	}
	outputs {
		name=DeInter_flow_tx
		remote_itf=Depunc_flow_rx
		remote_obj=depunc
		bw = 100
	}
}

object {
	obj_name=depunc
	exe_name=depunc
	proc=100
	inputs {
		name=Depunc_flow_rx
		remote_itf=DeInter_flow_tx
		remote_obj=deinter
	}
	outputs {
		name=Depunc_flow_tx
		remote_itf=Viterbi_flow_rx
		remote_obj=viterbi
		bw = 100
	}
}

object {
	obj_name=viterbi
	exe_name=viterbi
	proc=100
	inputs {
		name=Viterbi_flow_rx
		remote_itf=Depunc_flow_tx
		remote_obj=depunc
	}
	outputs {
		name=Viterbi_flow_tx
		remote_itf=deRSol_flow_rx
		remote_obj=dersol
		bw = 100
	}
}

object {
	obj_name=dersol
	exe_name=dersol
	proc=100
	inputs {
		name=deRSol_flow_rx
		remote_itf=Viterbi_flow_tx
		remote_obj=viterbi
	}
	outputs {
		name=deRSol_flow_tx
		remote_itf=deRando_flow_rx
		remote_obj=derando
		bw = 100
	}
}


object {
	obj_name=derando
	exe_name=derando
	proc=100
	inputs {
		name=deRando_flow_rx
		remote_itf=deRSol_flow_tx
		remote_obj=dersol
	}
}




