#include "calsoft_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("CALSOFT  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		calsoft_id=atoi(optarg);
			printf("calsoft id: %d\n",calsoft_id);
        	break;
		case 's':
        		depilot_id=atoi(optarg);
			printf("depilot id: %d\n",depilot_id);
        	break;		
		case 'd':
        		deinter_id=atoi(optarg);
			printf("deinter id: %d\n",deinter_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (depilot_id<0 || calsoft_id<0 || deinter_id<0)
	{
		printf("Need two mandatory parameter: -m <calsoft_id> -s <depilot_id> -d <deinter_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"CALSOFT");
	n=InitCommManagerN(calsoft_id,modulename);
	if(n<0) return(-1);


	printf("Register module CALSOFT: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			CALSOFT_Init();
			CALSOFT_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 CALSOFT_Stat_Run0();
			 CALSOFT_Run();
			 CALSOFT_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 CALSOFT_Stop();
			 CALSOFT_Stat_Stop();
		}
	}

	return(1);

}
