#include "estadisticas_cm.h"
int n_bucle=-1;
int n_multiple=0;

/**********************************************************
INIT
**********************************************************/
void ESTADISTICAS_Init()
{
  struct flow_config fconf,fconf2;

	//printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Estadisitcas_rx\n");
	//Create CHANNELflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 3600;
	fconf.magic = (pilot_id*estadisticas_id)%(pilot_id+estadisticas_id);
	fconf.name = "Estadisticas_flow_rx";
	Estadisticas_flow_rx = NewFlow(estadisticas_id, pilot_id, fconf);
	if (Estadisticas_flow_rx<0) UnrecoveryError("Could not create flow with Pilot");
	WriteLog(logCMFile, "Estadisticasflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Estadisticasflow_rx2\n");
	//Create Ifftflow_tx
	
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3600;
	fconf2.magic = (depilot_id*estadisticas_id)%(depilot_id+estadisticas_id);
	fconf2.name = "Estadisticas_flow_rx2";
	Estadisticas_flow_rx2 = NewFlow(estadisticas_id, depilot_id, fconf2);
	if (Estadisticas_flow_rx2<0) UnrecoveryError("Could not create flow with Depilot");
	WriteLog(logCMFile, "Estadisticasflow_rx2: OK\n");
	
	time_slot=0; 
	}		

/*************************************************************
STOP
************************************************************/	
void ESTADISTICAS_Stop() {
		
	DeleteFlow(Estadisticas_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Estadisticas_flow_rx\n");

	DeleteFlow(Estadisticas_flow_rx2);
	WriteLog(logCMFile, "DeleteFlow Estadisticas_flow_rx2\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(estadisticas_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void ESTADISTICAS_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i,bucle;
	pilot2estadisticas flow_rx;
	depilot2estadisticas flow_rx2;
	float real[256], imag[256];
	FILE *ff1,*ff2;
	pilot2estadisticas info_old[6000];
	//depilot2estadisticas info_new[2500];

	if(GetFlowStatus(Estadisticas_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Estadisticas_flow_rx,sizeof(flow_rx),&flow_rx);
		//printf("readflow: %d\n", n);
		
		sprintf(log_msg,"read bytes:%d",n);
		WriteLog(logCMFile, log_msg);
		

		if (n>0)
		{
		
		//printf("num_tx: %d\n",flow_rx.num_tx);
		//printf("Hay datos de Pilot\n");
		if(flow_rx.num_tx<6000){
		for(i=0;i<192;i++){

			info_old[flow_rx.num_tx].asymbol[i].re=flow_rx.asymbol[i].re;
			info_old[flow_rx.num_tx].asymbol[i].im=flow_rx.asymbol[i].im;
		}
		info_old[flow_rx.num_tx].length=flow_rx.length*8;
		info_old[flow_rx.num_tx].num_tx=flow_rx.num_tx;
		info_old[flow_rx.num_tx].mod=flow_rx.mod;
		}
		
		/*for (i=0; i<192; i++)
		{
			printf("real [%d]: %f\n",i,flow_rx.asymbol[i].re);
				//WriteLog(logCMFile,log_msg);

			printf("imag [%d]: %f\n",i,flow_rx.asymbol[i].im);
				//WriteLog(logCMFile,log_msg);
		}*/
		
		
		
		if(GetFlowStatus(Estadisticas_flow_rx2))
			
			{
			n=ReadFlow(Estadisticas_flow_rx2,sizeof(flow_rx2),&flow_rx2);
			//sprintf(prueba,"flow_tx: %f\n",flow_tx);
			//write (1,prueba,sizeof(prueba));
			if(n>0){
			

			printf("Hay datos de Depilot\n");

			
			if ((flow_rx2.num_tx<6000)&&(info_old[flow_rx2.num_tx].num_tx!=0))
			ber(info_old[flow_rx2.num_tx].length,-1, ff1,ff2,info_old[flow_rx2.num_tx].asymbol,flow_rx2.asymbol,info_old[flow_rx2.num_tx].mod);
			//compara((flow_rx.length*8),-1,ff1,ff2,flow_rx.asymbol,flow_rx2.asymbol);


			/*for (i=0; i<192; i++)
			{
			printf("real [%d]: %f\n",i,flow_rx2.asymbol[i].re);
				//WriteLog(logCMFile,log_msg);

			printf("imag [%d]: %f\n",i,flow_rx2.asymbol[i].im);
				//WriteLog(logCMFile,log_msg);

			}*/
			/*if (info_old[flow_rx2.num_tx].num_tx!=0){
			for(i=0;i<192;i++){
			printf("real[%d]:%f = %f\n",i,info_old[flow_rx2.num_tx].asymbol[i].re,flow_rx2.asymbol[i].re);
			printf("imag[%d]:%f = %f\n",i,info_old[flow_rx2.num_tx].asymbol[i].im,flow_rx2.asymbol[i].im);

			}
			}*/
			/*for(i=0;i<192;i++){
			printf("real[%d]:%f = %f\n",i,flow_rx.asymbol[i].re,flow_rx2.asymbol[i].re);
			printf("imag[%d]:%f = %f\n",i,flow_rx.asymbol[i].im,flow_rx2.asymbol[i].im);
			}*/
			
			/*if (info_old[flow_rx2.num_tx].num_tx!=0)
			printf("num_tx: %d = %d\n",info_old[flow_rx2.num_tx].num_tx,flow_rx2.num_tx);*/

			/*for(i=0;i<192;i++){

			info_new[flow_rx2.num_tx].asymbol[i].re=flow_rx2.asymbol[i].re;
			info_new[flow_rx2.num_tx].asymbol[i].im=flow_rx2.asymbol[i].im;
			}
			info_new[flow_rx2.num_tx].num_tx=flow_rx2.num_tx;
			}*/
				
			}
		
		
		}

	
	}
	/*if(n_retardo>1000){
		compara(info_old[n_retardo-1000].length,-1, ff1,ff2,info_old[n_retardo-1000].asymbol,info_new[n_retardo-1000].asymbol);
	
			for(i=0;i<192;i++){
			printf("real[%d]:%f = %f\n",i,info_old[n_retardo-500].asymbol[i].re,info_new[n_retardo-500].asymbol[i].re);
			printf("imag[%d]:%f = %f\n",i,info_old[n_retardo-500].asymbol[i].im,info_new[n_retardo-500].asymbol[i].im);

			}*/
	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Estadisticas time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);
	Relinquish(1);
}

