#include "derando_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
  
	printf("DERANDO  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:")) != -1)//d:
		switch(c){
		case 'm':
        		derando_id=atoi(optarg);
			printf("deRando id: %d\n",derando_id);
        	break;
		case 's':
        		dersol_id=atoi(optarg);
			printf("Rsolomon id: %d\n",dersol_id);
        	break;		
	/*	case 'd':
        		result_id=atoi(optarg);
			printf("Result id: %d\n",result_id);

        	break;*/

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}
	
	if (derando_id<0 || dersol_id<0)//result_id<0
	{
		printf("Need two mandatory parameter: -m <derando_id> -s <dersol_id> -d <result_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"DERANDO");
	n=InitCommManagerN(derando_id,modulename);
	if(n<0) return(-1);


	printf("Register module DERANDO: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT)
		{
			 DERANDO_Init();
			 DERANDO_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 DERANDO_Stat_Run0();
			 DERANDO_Run();
			 DERANDO_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			DERANDO_Stop();
			DERANDO_Stat_Stop();
		}
	}

	return(1);

}
