#ifndef APP_INCLUDED
#define APP_INCLUDED

#define T app_o

/** @defgroup app P-HAL Application 
 * @ingroup common_obj
 *
 * Manages an application, its execution status and the objects belonging to it. 
 *
 * @{
 */

typedef struct T *T;

struct T
{
	appid_t app_id;
	str_o name;
	Set_o objects;
	status_t cur_status;
};

T app_new ();
void app_delete(T *app);

int app_findname(const void *x, const void *member);
int app_findid(const void *x, const void *member);

int app_topkt(void *x, char **start, char *end);
void * app_newfrompkt(char **start, char *end);

void app_xdelete(void **x);
void app_sdelete(void **x);

/** @} */

#undef T
#endif /*  */
