#ifndef pe_INCLUDED
#define pe_INCLUDED

#define T pe_o

/** @defgroup app P-HAL Application 
 * @ingroup common_obj
 *
 * Manages an application, its execution status and the objects belonging to it. 
 *
 * @{
 */

typedef struct T *T;

struct T
{
	peid_t id;
	int plat_family;
	int P_idx;
	int BW_idx;
	float C;
	char is_hwman;
	Set_o xitfs;
};

T pe_new ();
void pe_delete(T *app);

int pe_findid(const void *x, const void *member);
int pe_findPidx(const void *x, const void *member);

int pe_topkt(void *x, char **start, char *end);
void * pe_newfrompkt(char **start, char *end);

/** @} */

#undef T
#endif /*  */
