#ifndef xitf_INCLUDED
#define xitf_INCLUDED

#define T xitf_o

/** @defgroup app P-HAL Application 
 * @ingroup common_obj
 *
 * Manages an application, its execution status and the objects belonging to it. 
 *
 * @{
 */

typedef struct T *T;

struct T
{
	struct hwapi_xitf_i xitf;
	xitfid_t remote_id;
	peid_t remote_pe;
};

T xitf_new ();
void xitf_delete(T *app);

int xitf_findid(const void *x, const void *member);
int xitf_findremotepe(const void *x, const void *member);

int xitf_topkt(void *x, char **start, char *end);
void * xitf_newfrompkt(char **start, char *end);

void xitf_xdelete(void **x);

/** @} */

#undef T
#endif /*  */
