/* ###################### MAIN FUNCTION PROTOTYPES ###################### */

/*  CM functions  */
/* -------------- */
void CRM_Init(void);
void CRM_Run(void);
void CRM_Stop(void);

/*  Supporting functions  */
/* ---------------------- */
// prints a help message on how to execute the CRM module 
void usage();

// processing model (SDR function chains)
void processing_model();

// resource model (SDR platforms)
void resource_model_UT(float Px, float Bx);

// resource model (SDR platforms)
void resource_model_BTS(float Px, float Bx);

// tw-mapping algorithm (w = 1, 2, 3, 4, 5): 
float tw_mapping(int M, int w);

// g-mapping, or t0-mapping, algorithm
float g_mapping(int M);


