#include "crm.h"

/* ###################### GLOBAL VARIABLES ###################### */


// processing model
float b[Mmax][Mmax];			// connectivity matrix: a '1' @ b[i][j] denotes that m[i] send data to m[j]
float m_sort[Mmax];			// sorted current task graph's processing requirements
int MM;						// number of SDR functions per SDR application
int sortx = 0;					// ordering index: 0 - no ordering, 1 - ordering due to decreasing processing requirements, 2 - ordering due to decreasing bandwidth requirements

int w_global = 1;				// window size, initialized with 1

/* isma */
int N=0; 		/* nof processors */
      /* substituim N->Nmax (numero maxim de processador) per utilitzarem N en el mapeig.
      N passa llavors a ser una variable.
/* -- */

// resource models
float P[Nmax];					// processing powers of Nmax processors per resource model
float B[Nmax][Nmax];				// Bandwidth matrices

float Px = (float)4000;			// initial Processing capacities
float Bx = (float)2000;			// initial Bandwidth capcities

	
// tw-mapping
float a_pathsU[Nmax+1][Nmax*Mmax];	// path costs
int PP[Nmax][Mmax][Mmax];			// Nmax*M matrix of Trellis nodes, each nodes contains the whole mapping up to this step
int ptr_nodes[Nmax][Mmax];			// trellis organization

// cost function
float q1 = (float)0.5;			// q1 in [0..1]
float q2 = (float)0.5;			// q2 = 1 - q1

// architecture type
int arch;					// FULL DUPLEX (arch = 0), HALF DUPLEX (arch = 1), or BUS system (arch = 2)

// multi-hop
int mhop = 0;					// multi-hop indicator; mhop = 0: single hops only, mhop = 1: 2-hop only if necessary, mhop = 2: single & 2-hops 

// remaining resources
float P_saved[Nmax];				// remaining processing powers
float B_saved[Nmax][Nmax];			// remaining bandwidths

// global variables for dummy operations
int first_time = -1;
int num = 0;					// number of feasible mapping
//int BTSindx = 1;				// 1 means that last mapping was feasible => continue mapping SDR applications on BTS-SDR platform

int P_m[Mmax];				// process m[i] is assigned processor 'P_m[i]', i.e. vector P_m[] represents the g-mapping result

