// function that updates the remaining resources
// FULL-DUPLEX, HALF-DUPLEX, or BUS architectures

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "crm.h"

extern int arch;			// FULL DUPLEX (arch = 0), HALF DUPLEX (arch = 1), or BUS system (arch = 2)


void update(float bx, float (*B_rem)[Nmax], int indx1, int indx2)
{
	// update remaining bandwidth for...
	if (arch == HD)		// ...Half-Duplex architectures
	{
		B_rem[indx1][indx2] -= bx;
		B_rem[indx2][indx1] -= bx;
	}

}
