#include "utils.h"

int bin2char (int v[], unsigned char msg[], int bits)
{
	int i,j,sum=0;
	int b=1;

	int tmp[8];

	for (i=0; i<(bits/8); i++)
	{
		sum=0;
		b=1;
		for(j=0; j<8; j++)
		{
			tmp[j]=v[j+i*8];

//			printf("[%d], ",tmp[j]);printf("%d\n",j+i*8);
		}
		for (j=0; j<8; j++)
		{
			sum+=(b*tmp[j]);
			b*=2;
		}
		msg[i]=sum;
//		printf("{%d}\n", msg[i]);
	}

	return (bits/8);
}

int char2bin (int vout[], unsigned char code[],int bytes)
{
	int  i,k;
	int  remain;

	for (i=0; i<bytes; i++)
	{
		for (k=0; k<8; k++)
		{
			remain = code[i] % 2;
			code[i] = code[i] / 2;

			vout[k+i*8]=remain;
		}
	}
	return (bytes*8);
}

void int2char (int in[],int len, char out [])
{
	int i;
	for (i=0; i<len; i++)
	{
		out[i]=in[i];
	}
}

void char2float(char in[], int len, float out [])
{
	int i;
	char tmp[2];

	for (i=0; i<len; i++)
	{
		sprintf(tmp,"%d\0",in[i]);
		out[i]=(float)(atoi(tmp));
	}

}

void char2int(char in[], int len, int out [])
{
	int i;
	char tmp[2];

	for (i=0; i<len; i++)
	{
		sprintf(tmp,"%d\0",in[i]);
		out[i]=atoi(tmp);
	}

}

void lee_archivo(char nombre[],char array[],int n_times,int length_max)
{
	char i=0;
	int j=0;
	FILE *f;
	f=fopen(nombre,"r");
//	 printf("%s",nombre);
	if(f==NULL)
	{
		printf("Error al abrir fichero %s\n", nombre);
		exit(0);
	}
	fseek(f,n_times*length_max,SEEK_SET);

	fscanf(f,"%c",&i);
        array[j]=i;
	j++;
    	while(!feof(f)&&(j<length_max))
     	{
   		fscanf(f,"%c",&i);
             	array[j]=i;
           	j++;
     	}
     	fclose(f);
}


void escribe_archivo(char nombre[],unsigned char data[], int length_max)
{
     int i;
     FILE *f;
      f=fopen(nombre,"a"); //Crear fichero

      for(i=0;i<length_max;i++)
      {
         fprintf(f,"%c",data[i]);// Escribe

      }
      fclose(f); //Cerrar fichero
}

