#include "deinter_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("DEINTER  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		deinter_id=atoi(optarg);
			printf("deInter id: %d\n",deinter_id);
        	break;
		case 's':
        		calsoft_id=atoi(optarg);
			printf("Calsoft id: %d\n",calsoft_id);
        	break;		
		case 'd':
        		depunc_id=atoi(optarg);
			printf("depunct id: %d\n",depunc_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (calsoft_id<0 || deinter_id<0 || depunc_id<0)
	{
		printf("Need two mandatory parameter: -m <deinter_id> -s <calsoft_id> -d <depunc_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"DEINTER");
	n=InitCommManagerN(deinter_id,modulename);
	if(n<0) return(-1);


	printf("Register module DEINTER: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			DEINTER_Init();
			DEINTER_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN) 
		{
			DEINTER_Stat_Run0();
			DEINTER_Run();
			DEINTER_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 DEINTER_Stop();
			 DEINTER_Stat_Stop();
		}
	}

	return(1);

}
