#include "estadisticas_cm.h"
 int log_id;
double sts_count;
/*char log_msg[20];*/
struct timeval tm1, tm2;

//INIT SECTION
void ESTADISTICAS_Stat_Init()
{
	log_id=CreateLog();										/*Creating th log */
	if ((n=InitStatistics(estadisticas_id))<0)                   /*Initialising the statistics for the module */ 
		UnrecoveryError("Error initialising Statistics");  
	sts_count=0;											
	//stats_SER = CreateStat("ESTADISTICAS")						/*Creating the stat referenced on module_XXX.sts */
	stats_SER = CreateStat("SER");
	sprintf(log_msg,"Stats of Module_ESTADISTICAS started succesfully");
	WriteLog(log_id,log_msg);	
}

//RUN SECTION
void ESTADISTICAS_Stat_Run0()
{
		gettimeofday(&tm1,NULL);							/*getting the time before process the module (tm1) */
}
void ESTADISTICAS_Stat_Run1()
{
	gettimeofday(&tm2,NULL);								/*getting the time after procces the module (tm2) */
	sts_count = (tm2.tv_usec-tm1.tv_usec);					/*difference between two times */
	sprintf(log_msg,"Module_ESTADISTICAS time %f us",&sts_count);		/*Log the result in LogFile and Statistics */
	WriteLog(log_id, log_msg);
	SetStatValue(stats_SER,&sts_count,0);
	LogStat(log_id,stats_SER,0);
}
void ESTADISTICAS_Stat_Stop()
{
	DeleteStat(stats_SER);									/* Delete variable stats for the module */
	//CloseStatistics();
	sprintf(log_msg,"Stats of Module_ESTADISTICAS stopped succesfully");
	WriteLog(log_id,log_msg);
}
