#include "inter_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("INTER  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		inter_id=atoi(optarg);
			printf("Inter id: %d\n",inter_id);
        	break;
		case 's':
        		cconv_id=atoi(optarg);
			printf("Cconv id: %d\n",cconv_id);
        	break;		
		case 'd':
        		smap_id=atoi(optarg);
			printf("Smap id: %d\n",smap_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (cconv_id<0 || inter_id<0 || smap_id<0)
	{
		printf("Need two mandatory parameter: -m <inter_id> -s <cconv_id> -d <smap_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"INTER");
	n=InitCommManagerN(inter_id,modulename);
	if(n<0) return(-1);


	printf("Register module INTER: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			INTER_Init();
			INTER_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN) 
		{
			INTER_Stat_Run0();
			INTER_Run();
			INTER_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			INTER_Stop();
			INTER_Stat_Stop();
		}
	}

	return(1);

}
