#ifndef MEM_INCLUDED
#define MEM_INCLUDED
#define T mem_o

/** @defgroup mem Memory Pool manager
 * @ingroup common_base
 * @{
 */
typedef struct T *T;


void * mem_new (void *addr, int buff_sz, int nof_chunks);

void mem_delete (void *addr);

void * mem_alloc (void *addr, int size);

void * mem_calloc (void *addr, int size);

void mem_free (void *addr, void *ptr);

void * mem_realloc (void *addr, void *ptr);



/** @} */

#undef T
#endif
