#include <stdio.h>
#include <math.h>

/* accion=1 en el transmisor -> add cyclic prefix
   accion=-1 en el receptor -> 	remove cyclic prefix*/

/* m = n de puntos de la IFFT o FFT */
/* array x = parte real, array y = parte imaginaria */


int cyclic (int accion,int m, float *x,float *y)

{

	float var=0.0;
	int i=0, j=0, k=0;

	/*add or remove 0.25*m points of symbol*/

	

	float copy_real[100];
	float copy_imag[100]; 
	float final_real[500];
	float final_imag[500]; /*m+var= symbol + cyclic prefix */

	var= m * 0.25;

	//printf("Var:%f\n",var);

	j=m - var;  /* en nuestro caso j=192, punto a partir del cual tenemos que copiar o borrar*/

	if (accion == 1)
	{
		for(i=0;i<var;i++)
		{
			copy_real[i]=x[i+j];
			copy_imag[i]=y[i+j];
		}
		
		for(i=0;i<var;i++)
		{
			final_real[i]= copy_real[i];
			final_imag[i]= copy_imag[i];
		}
		
		for(i=var;i<m+var;i++)
		{
			
			final_real[i]= x[k];
			final_imag[i]= y[k];
			k++;
		}
	}

	
	/*for (k=0;k<(m+var);k++) {
	
		printf("Real:%f",final_real[k]);
		printf("Imag:%f",final_imag[k]);
   }*/

	return(0);

}

	
