#include "rando_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
  
	printf("RANDO  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		rando_id=atoi(optarg);
			printf("Rando id: %d\n",rando_id);
        	break;
		case 's':
        		buffer_id=atoi(optarg);
			printf("Buffer id: %d\n",buffer_id);
        	break;		
		case 'd':
        		rsolomon_id=atoi(optarg);
			printf("Rsolomon id: %d\n",rsolomon_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}
	
	if (rando_id<0 ||buffer_id<0)//rsolomon_id<0
	{
		printf("Need two mandatory parameter: -m <rando_id> -s <buffer_id> -d <rsolomon_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"RANDO");
	n=InitCommManagerN(rando_id,modulename);
	if(n<0) return(-1);


	printf("Register module RANDO: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			RANDO_Init();
			RANDO_Stat_Init();
		}
		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			RANDO_Stat_Run0(); 
			RANDO_Run();
			RANDO_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			RANDO_Stop();
			RANDO_Stat_Stop();
		}
	}

	return(1);

}
