

#define BRIDGE_IDENT_MAGIC	0x00000000 /* replaces header, can't be any combination of possible obj_id or itf_id */

typedef struct ph_header {
	itfid_t ItfId;
	objid_t ObjId;
} data_header_t;

#define PH_HEADER_SZ (sizeof (struct ph_header)>>2)

/* DEFINITIONS FOR BRIDGE itf TABLE*/
struct bridge_itf {
	int fd_r;
	int fd_w;
	data_header_t dest; 						
	int mode;
};

struct ext_itf
{
	int id;
	int itf_id;
	int fd;
	int xitf_pos;
};

struct bridge_ident {
	int magic;
	int pe_id;
	struct hwapi_xitf_i xitf;
};
	
#define BIDENT_PKT_SZ	(sizeof(struct bridge_ident)>>2)
#ifndef BRIDGE_H_
#define BRIDGE_H_

#endif /*BRIDGE_H_*/
