
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>


#define K_LENGTH 239 // Gràndaria del msg (sense padding) 
#define N_LENGTH 255

#define NPAR (N_LENGTH-K_LENGTH)
#define MAXDEG (NPAR*2)

/* generator polynomial */
int genPoly[MAXDEG*2];
int pBytes[MAXDEG];

int gexp[512];
int glog[256];

void encode_data (unsigned char msg[], int nbytes, unsigned char dst[]);
void compute_genpoly (int nbytes, int genpoly[]);
void build_codeword (unsigned char msg[], int nbytes, unsigned char dst[]);
void zero_poly (int poly[]);
void copy_poly (int dst[], int src[]);
void mult_polys (int dst[], int p1[], int p2[]);
int gmult(int a, int b);
void init_exp_table (void);
void fillzero (unsigned char info_in[], unsigned char msg[],int *bitmod);
void delredundant (unsigned char code[],int difmod, int inmod);






